﻿-- Author      : Administrator
-- Create Date : 9/10/2008 6:44:47 PM
SLICECMDR = { };
SLICECMDR.AlertPending = 0;
SLICECMDR.LastTime = 0;
SLICECMDR.BarFont = 0;
SLICECMDR.LastEnergy = 0;
SLICECMDR.SliceExpires = 0;
SLICECMDR.HungerExpires = 0;
SLICECMDR.LastSliceExpire = 0;
SLICECMDR.tNow = 0;

SLICECMDR.BARS = { 
	['HfB'] = {
		['obj'] = 0,
		['Expires'] = 0,
		['AlertPending'] = 0
	},
	['SnD'] = {
		['obj'] = 0,
		['Expires'] = 0
	},

};

function SliceCmdr_MoveStart()
	if (SliceCmdr_Save.IsLocked == false) then
		SliceCmdr:StartMoving();
	 end
end

function SliceCmdr_MoveStop()
	if (SliceCmdr_Save.IsLocked == false) then
		SliceCmdr:StopMovingOrSizing();
	end		
end

function SliceCmdr_SoundTest(name) 
	if (SliceCmdr_Sounds[name]) then
		PlaySoundFile( SliceCmdr_Sounds[name] );
	end
end

function SliceCmdr_Sound(saved) 
	if (SliceCmdr_Save[saved]) then
		PlaySoundFile( SliceCmdr_Sounds[ SliceCmdr_Save[saved] ] );
	end
end

function SliceCmdr_OnEvent(self, event, ...)
	if (event == "COMBAT_LOG_EVENT_UNFILTERED") then
		local timestamp, type, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags = select(1, ...);
		if (type == "SPELL_AURA_REFRESH" or type == "SPELL_AURA_APPLIED" or type == "SPELL_AURA_REMOVED" or type == "SPELL_AURA_APPLIED_DOSE") then
			local spellId, spellName, spellSchool = select(9, ...);
			
			if (destName == UnitName("player")) then
				if (spellName == SC_SPELL_SND) then
					if (type == "SPELL_AURA_REMOVED") then
						if (UnitAffectingCombat("player")) then
							SliceCmdr_Sound("Fail");
						else
							SliceCmdr_Sound("Expire");
						end					
						SLICECMDR.SliceExpires = 0;
						SLICECMDR.BARS['HfB']['obj']:SetPoint("TOPLEFT", VTimerEnergy, "BOTTOMLEFT", 0, -2);
						SLICECMDR.BARS['SnD']['obj']:Hide();
					else
						local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitAura("player", SC_SPELL_SND);
						local timeLeftOnLast = SLICECMDR.SliceExpires - GetTime();
						SLICECMDR.BARS['SnD']['obj']:Show();
						SLICECMDR.SliceExpires = expirationTime;
						SLICECMDR.BARS['HfB']['obj']:SetPoint("TOPLEFT", SLICECMDR.BARS['SnD']['obj'], "BOTTOMLEFT", 0, -2);
						if (type == "SPELL_AURA_APPLIED") then
							SliceCmdr_Sound("Applied");
						else
							if (timeLeftOnLast <= 1) then
								SliceCmdr_Sound("Apply1");
							else
								if (timeLeftOnLast <= 2) then
									SliceCmdr_Sound("Apply2");
								else
									SliceCmdr_Sound("Apply3");
								end
							end
						end
					end
				end
				
				if (spellName == SC_SPELL_HFB) then
					if (type == "SPELL_AURA_REMOVED") then
						SLICECMDR.HungerExpires = 0;
						SLICECMDR.BARS['HfB']['Expires'] = 0;
						SLICECMDR.BARS['HfB']['obj']:Hide();
						if (UnitAffectingCombat("player")) then
							SliceCmdr_Sound("HfB.Fail");
						else
							SliceCmdr_Sound("HfB.Expire");
						end					
					else
						local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitAura("player", SC_SPELL_HFB);
						local timeLeftOnLast = SLICECMDR.HungerExpires - GetTime();
						SLICECMDR.HungerExpires = expirationTime;
						SLICECMDR.BARS['HfB']['Expires'] = expirationTime;
						SLICECMDR.BARS['HfB']['obj'].text2:SetText(count);
						if (type == "SPELL_AURA_APPLIED") then
							SliceCmdr_Sound('HfB.Applied');
						else
							if (timeLeftOnLast <= 1) then
								SliceCmdr_Sound('HfB.Refresh1');
							else
								if (timeLeftOnLast <= 2) then
									SliceCmdr_Sound('HfB.Refresh2');
								else
									SliceCmdr_Sound('HfB.Refresh3');
								end
							end							
						end
						
						if (count == 3) then
							SLICECMDR.BARS['HfB']['obj'].text2:SetText("");
						else
							if (count == 1) then
								SLICECMDR.BARS['HfB']['obj'].text2:SetText("HfB x1");
							else
								SLICECMDR.BARS['HfB']['obj'].text2:SetText("HfB x2");
							end
							--SLICECMDR.BARS['HfB']['obj'].text2:SetText(count);
						end
						
						SLICECMDR.BARS['HfB']['obj']:Show();
					end
				end
			end			
		end
		
	end
	
	if (event == "UNIT_COMBO_POINTS") then
		local unit = select(1, ...);
		if (unit and unit == "player") then 
			SliceCmdr_SetComboPts();
		end
	end
	if (event == "PLAYER_TARGET_CHANGED") then
		SliceCmdr_SetComboPts();
	end
end

function SliceCmdr_SetComboPts()
	local points = GetComboPoints("player");
	if (points >= 1) then
		SliceCmdr_Combo:SetText(points);
	else
		SliceCmdr_Combo:SetText("");
	end	
end

function SliceCmdr_Unload()
	SliceCmdr:UnregisterAllEvents();
	SliceCmdr:Hide();
end

			
function SliceCmdr_NewFrame()
	local f = CreateFrame("StatusBar", nil, UIParent);
	f:SetWidth(VTimerEnergy:GetWidth());
	f:SetScale(VTimerEnergy:GetScale());
	f:SetHeight(10);
	f:SetPoint("TOPLEFT", VTimerEnergy, "BOTTOMLEFT", 0, -2);
	f:SetStatusBarTexture("Interface\\AddOns\\SliceCommander\\Images\\Smooth.tga");
	f:SetStatusBarColor(0.768627451, 0, 0, 1);
	f:EnableMouse(false);
	f:SetMinMaxValues(0, 6.0);
	f:SetValue(0);

	f:Hide();
	
	f:SetBackdrop({
		  bgFile="Interface\\Tooltips\\UI-Tooltip-Background",
		  edgeFile="",
		  tile=true, tileSize=1, edgeSize=0,
		  insets={left=-1, right=-1, top=-1, bottom=-3}
		});
	f:SetBackdropBorderColor(1,1,1,1);
	f:SetBackdropColor(0,0,0,0.5);
				
	if not f.text then
		f.text = f:CreateFontString(nil, nil, "GameFontWhite")
	end
	f.text:SetFontObject(SLICECMDR.BarFont2);
	f.text:SetHeight(10)
	f.text:SetWidth(30);
	f.text:SetPoint("TOPRIGHT", f, "TOPRIGHT",  -5, 0);
	f.text:SetJustifyH("RIGHT")
	f.text:SetText("");
	
	if not f.text2 then
		f.text2 = f:CreateFontString(nil, nil, nil)
	end
	f.text2:SetFontObject(SLICECMDR.BarFont2);
	f.text2:SetHeight(10)
	f.text2:SetWidth(60);
	f.text2:SetPoint("TOPLEFT", f, "TOPLEFT",  1, 0);
	f.text2:SetJustifyH("LEFT")
	f.text2:SetText("");
	
	return f;
	
end

			
function SliceCmdr_OnLoad()
	local localizedClass, englishClass = UnitClass("player");
	if (englishClass == "ROGUE") then
		SliceCmdr:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
		SliceCmdr:RegisterEvent("UNIT_COMBO_POINTS");
		SLICECMDR.BarFont = CreateFont("VTimerFont");
		SLICECMDR.BarFont:SetFont("Fonts\\FRIZQT__.TTF", 12);
		SLICECMDR.BarFont:SetShadowColor(0,0,0, 0.7);
		SLICECMDR.BarFont:SetTextColor(1,1,1,1);
		SLICECMDR.BarFont:SetShadowOffset(0.8, -0.8);
		
		SLICECMDR.BarFont2 = CreateFont("VTimerFont2");
		SLICECMDR.BarFont2:SetFont("Fonts\\FRIZQT__.TTF", 8)
		SLICECMDR.BarFont2:SetShadowColor(0,0,0, 0.7);
		SLICECMDR.BarFont2:SetTextColor(213/255,200/255,184/255,1);
		SLICECMDR.BarFont2:SetShadowOffset(0.8, -0.8);
		
		SLICECMDR.BarFont3 = CreateFont("VTimerFont1O");
		SLICECMDR.BarFont3:SetFont("Fonts\\FRIZQT__.TTF", 12);
		SLICECMDR.BarFont3:SetShadowColor(0,0,0, 0.2);
		SLICECMDR.BarFont3:SetTextColor(0,0,0,1);
		SLICECMDR.BarFont3:SetShadowOffset(0.8, -0.8);

		
		SLICECMDR.LastEnergy = UnitMana('player');
		
		VTimerEnergyTxt:SetFontObject(SLICECMDR.BarFont);
		--VTimerEnergyTxt:SetShadowColor(0,0,0);
		SliceCmdr_Combo:SetFontObject(SLICECMDR.BarFont3);
		
		VTimerEnergy:SetMinMaxValues(0,UnitManaMax("player"));
		VTimerEnergy:SetBackdrop({
		  bgFile="Interface\\Tooltips\\UI-Tooltip-Background",
		  edgeFile="",
		  tile=true, tileSize=1, edgeSize=0,
		  insets={left=-1, right=-1, top=-1, bottom=0}
		});
		--"Interface\\TargetingFrame\\UI-StatusBar"
		VTimerEnergy:SetBackdropBorderColor(1,1,1,1);
		VTimerEnergy:SetBackdropColor(0,0,0,0.2);
		VTimerEnergy:SetStatusBarTexture("Interface\\AddOns\\SliceCommander\\Images\\Smooth.tga");
		VTimerEnergy:SetWidth(200);
		--234,178,57
		VTimerEnergy:SetStatusBarColor(254/255, 246/255, 226/255); 

		SLICECMDR.BARS['SnD']['obj'] = SliceCmdr_NewFrame();
		SLICECMDR.BARS['SnD']['obj']:SetStatusBarColor(255/255, 74/255, 18/255, 0.9);
				
		SLICECMDR.BARS['HfB']['obj'] = SliceCmdr_NewFrame();
		SLICECMDR.BARS['HfB']['obj']:SetStatusBarColor(130/255, 15/255, 0);
		SliceCmdr_OnUpdate();
	else
		SliceCmdr_Unload();
		return;
	end
	
end

function SliceCmdr_util_SnDBuffTime()
	if ((SLICECMDR.SliceExpires > 0) and (SLICECMDR.tNow < SLICECMDR.SliceExpires)) then
		return SLICECMDR.SliceExpires - SLICECMDR.tNow;
	else
		return 0;
	end
end

function SliceCmdr_util_HungerTime()
	if ((SLICECMDR.HungerExpires > 0) and (SLICECMDR.tNow < SLICECMDR.HungerExpires)) then
		return SLICECMDR.HungerExpires - SLICECMDR.tNow;
	else
		return 0;
	end
end


function SliceCmdr_HungerBar()
	local x = SliceCmdr_util_HungerTime();
	local hfb = SLICECMDR.BARS['HfB'];
	
	--gw_print(x);
	if (x > 0) then
		if (SLICECMDR.BARS['HfB']) then
			SLICECMDR.BARS['HfB']['obj']:SetValue(x);
			SLICECMDR.BARS['HfB']['obj'].text:SetText(string.format("%0.1f", x));
		end
		
		if (x <= 3) then
			if (hfb.AlertPending == 3) then
				SliceCmdr_Sound('HfB.Alert');
				hfb.AlertPending = 2;
			else 
				if (x <= 2) then
					if (hfb.AlertPending == 2) then
						SliceCmdr_Sound('HfB.Alert');
						hfb.AlertPending = 1;
					else 
						if (x <= 1) then
							if (hfb.AlertPending == 1) then
								SliceCmdr_Sound('HfB.Alert');
								hfb.AlertPending = 0;
							end
						end
					end
				end
			end
		else
			hfb.AlertPending = 3;
		end
		
	end	
	
end

function SliceCmdr_SNDCooldown() 
	SLICECMDR.tNow = GetTime();
	if (SliceCmdr_Save.PadLatency) then
		local down, up, lag = GetNetStats();
		SLICECMDR.tNow = SLICECMDR.tNow + (lag*2/1000);
	end	
		
	local x = SliceCmdr_util_SnDBuffTime();

	if (x > 0) then
		if (x <= 3) then
			if (SLICECMDR.AlertPending == 3) then
				SliceCmdr_Sound("Tick3");
				SLICECMDR.AlertPending = 2;
			else 
				if (x <= 2) then
					if (SLICECMDR.AlertPending == 2) then
						SliceCmdr_Sound("Tick2");
						SLICECMDR.AlertPending = 1;
					else 
						if (x <= 1) then
							if (SLICECMDR.AlertPending == 1) then
								SliceCmdr_Sound("Tick1");
								SLICECMDR.AlertPending = 0;
							end
						end
					end
				end
			end
		else
			SLICECMDR.AlertPending = 3;
		end
		
	end
	
	if (SLICECMDR.BARS['SnD']) then
		if (SLICECMDR.BARS['SnD']['obj']) then
			SLICECMDR.BARS['SnD']['obj']:SetValue(x);
			if (x > 0) then
				SLICECMDR.BARS['SnD']['obj'].text:SetText(string.format("%0.1f", x));
			else
				SLICECMDR.BARS['SnD']['obj'].text:SetText("");
			end		
		end			
	end
end

function SliceCmdr_OnUpdate()
	VTimerEnergy:SetValue(UnitMana("player"));
	VTimerEnergy:SetMinMaxValues(0,UnitManaMax("player"));
	
	if (UnitManaMax("player") == UnitMana('player')) then
		VTimerEnergyTxt:SetText("");
	else
		VTimerEnergyTxt:SetText(UnitMana("player"));
	end			
	
	SliceCmdr_Config_OtherVars();
	
	if (SLICECMDR.LastEnergy < UnitMana('player')) then
		if ((SLICECMDR.LastEnergy < SliceCmdr_Save.Energy2) and (UnitMana('player') >= SliceCmdr_Save.Energy2)) then
			SliceCmdr_Sound("EnergySound2");
		else
			if ((SLICECMDR.LastEnergy < SliceCmdr_Save.Energy1) and (UnitMana('player') >= SliceCmdr_Save.Energy1)) then
				SliceCmdr_Sound("EnergySound1");
			end
		end
		if (UnitManaMax("player") == UnitMana('player')) then
			--VTimerEnergy:Hide();
			VTimerEnergy:SetAlpha(0.2);
		else
			--VTimerEnergy:Show();
			VTimerEnergy:SetAlpha(1.0);
		end
	end
	
	SLICECMDR.LastEnergy = UnitMana('player');
	SliceCmdr_SNDCooldown();
	SliceCmdr_HungerBar();
end